package com.ustadmobile.core.db.dao;

import android.database.Cursor;
import androidx.room.CoroutinesRoom;
import androidx.room.EntityDeletionOrUpdateAdapter;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import com.ustadmobile.lib.db.entities.ClazzLog;
import com.ustadmobile.lib.db.entities.ScheduledCheck;
import java.lang.Class;
import java.lang.Exception;
import java.lang.Long;
import java.lang.Object;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import kotlin.coroutines.Continuation;

@SuppressWarnings({"unchecked", "deprecation"})
public final class ScheduledCheckDao_Impl extends ScheduledCheckDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<ScheduledCheck> __insertionAdapterOfScheduledCheck;

  private final EntityDeletionOrUpdateAdapter<ScheduledCheck> __deletionAdapterOfScheduledCheck;

  private final EntityDeletionOrUpdateAdapter<ScheduledCheck> __updateAdapterOfScheduledCheck;

  public ScheduledCheckDao_Impl(RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfScheduledCheck = new EntityInsertionAdapter<ScheduledCheck>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `ScheduledCheck` (`scheduledCheckUid`,`checkTime`,`checkType`,`checkUuid`,`checkParameters`,`scClazzLogUid`,`scheduledCheckMasterCsn`,`scheduledCheckLocalCsn`,`scheduledCheckLastChangedBy`,`scheduledCheckLct`) VALUES (nullif(?, 0),?,?,?,?,?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, ScheduledCheck value) {
        stmt.bindLong(1, value.getScheduledCheckUid());
        stmt.bindLong(2, value.getCheckTime());
        stmt.bindLong(3, value.getCheckType());
        if (value.getCheckUuid() == null) {
          stmt.bindNull(4);
        } else {
          stmt.bindString(4, value.getCheckUuid());
        }
        if (value.getCheckParameters() == null) {
          stmt.bindNull(5);
        } else {
          stmt.bindString(5, value.getCheckParameters());
        }
        stmt.bindLong(6, value.getScClazzLogUid());
        stmt.bindLong(7, value.getScheduledCheckMasterCsn());
        stmt.bindLong(8, value.getScheduledCheckLocalCsn());
        stmt.bindLong(9, value.getScheduledCheckLastChangedBy());
        stmt.bindLong(10, value.getScheduledCheckLct());
      }
    };
    this.__deletionAdapterOfScheduledCheck = new EntityDeletionOrUpdateAdapter<ScheduledCheck>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `ScheduledCheck` WHERE `scheduledCheckUid` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, ScheduledCheck value) {
        stmt.bindLong(1, value.getScheduledCheckUid());
      }
    };
    this.__updateAdapterOfScheduledCheck = new EntityDeletionOrUpdateAdapter<ScheduledCheck>(__db) {
      @Override
      public String createQuery() {
        return "UPDATE OR ABORT `ScheduledCheck` SET `scheduledCheckUid` = ?,`checkTime` = ?,`checkType` = ?,`checkUuid` = ?,`checkParameters` = ?,`scClazzLogUid` = ?,`scheduledCheckMasterCsn` = ?,`scheduledCheckLocalCsn` = ?,`scheduledCheckLastChangedBy` = ?,`scheduledCheckLct` = ? WHERE `scheduledCheckUid` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, ScheduledCheck value) {
        stmt.bindLong(1, value.getScheduledCheckUid());
        stmt.bindLong(2, value.getCheckTime());
        stmt.bindLong(3, value.getCheckType());
        if (value.getCheckUuid() == null) {
          stmt.bindNull(4);
        } else {
          stmt.bindString(4, value.getCheckUuid());
        }
        if (value.getCheckParameters() == null) {
          stmt.bindNull(5);
        } else {
          stmt.bindString(5, value.getCheckParameters());
        }
        stmt.bindLong(6, value.getScClazzLogUid());
        stmt.bindLong(7, value.getScheduledCheckMasterCsn());
        stmt.bindLong(8, value.getScheduledCheckLocalCsn());
        stmt.bindLong(9, value.getScheduledCheckLastChangedBy());
        stmt.bindLong(10, value.getScheduledCheckLct());
        stmt.bindLong(11, value.getScheduledCheckUid());
      }
    };
  }

  @Override
  public long insert(final ScheduledCheck entity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      long _result = __insertionAdapterOfScheduledCheck.insertAndReturnId(entity);
      __db.setTransactionSuccessful();
      return _result;
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public Object insertAsync(final ScheduledCheck entity,
      final Continuation<? super Long> continuation) {
    return CoroutinesRoom.execute(__db, true, new Callable<Long>() {
      @Override
      public Long call() throws Exception {
        __db.beginTransaction();
        try {
          long _result = __insertionAdapterOfScheduledCheck.insertAndReturnId(entity);
          __db.setTransactionSuccessful();
          return _result;
        } finally {
          __db.endTransaction();
        }
      }
    }, continuation);
  }

  @Override
  public void insertList(final List<? extends ScheduledCheck> entityList) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfScheduledCheck.insert(entityList);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void deleteCheck(final ScheduledCheck scheduledCheck) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __deletionAdapterOfScheduledCheck.handle(scheduledCheck);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void updateList(final List<? extends ScheduledCheck> entityList) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __updateAdapterOfScheduledCheck.handleMultiple(entityList);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void update(final ScheduledCheck entity) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __updateAdapterOfScheduledCheck.handle(entity);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public List<ClazzLog> findPendingLogsWithoutScheduledCheck(final int checkType,
      final long fromDate) {
    final String _sql = "SELECT ClazzLog.* FROM ClazzLog  WHERE NOT EXISTS(SELECT scClazzLogUid FROM ScheduledCheck WHERE  scClazzLogUid = ClazzLog.clazzLogUid AND ScheduledCheck.checkType = ?)  AND ClazzLog.logDate >= ?";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 2);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, checkType);
    _argIndex = 2;
    _statement.bindLong(_argIndex, fromDate);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfClazzLogUid = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogUid");
      final int _cursorIndexOfClazzLogClazzUid = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogClazzUid");
      final int _cursorIndexOfLogDate = CursorUtil.getColumnIndexOrThrow(_cursor, "logDate");
      final int _cursorIndexOfTimeRecorded = CursorUtil.getColumnIndexOrThrow(_cursor, "timeRecorded");
      final int _cursorIndexOfClazzLogDone = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogDone");
      final int _cursorIndexOfCancellationNote = CursorUtil.getColumnIndexOrThrow(_cursor, "cancellationNote");
      final int _cursorIndexOfClazzLogCancelled = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogCancelled");
      final int _cursorIndexOfClazzLogNumPresent = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogNumPresent");
      final int _cursorIndexOfClazzLogNumAbsent = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogNumAbsent");
      final int _cursorIndexOfClazzLogNumPartial = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogNumPartial");
      final int _cursorIndexOfClazzLogScheduleUid = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogScheduleUid");
      final int _cursorIndexOfClazzLogStatusFlag = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogStatusFlag");
      final int _cursorIndexOfClazzLogMSQN = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogMSQN");
      final int _cursorIndexOfClazzLogLCSN = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogLCSN");
      final int _cursorIndexOfClazzLogLCB = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogLCB");
      final int _cursorIndexOfClazzLogLastChangedTime = CursorUtil.getColumnIndexOrThrow(_cursor, "clazzLogLastChangedTime");
      final List<ClazzLog> _result = new ArrayList<ClazzLog>(_cursor.getCount());
      while(_cursor.moveToNext()) {
        final ClazzLog _item;
        _item = new ClazzLog();
        final long _tmpClazzLogUid;
        _tmpClazzLogUid = _cursor.getLong(_cursorIndexOfClazzLogUid);
        _item.setClazzLogUid(_tmpClazzLogUid);
        final long _tmpClazzLogClazzUid;
        _tmpClazzLogClazzUid = _cursor.getLong(_cursorIndexOfClazzLogClazzUid);
        _item.setClazzLogClazzUid(_tmpClazzLogClazzUid);
        final long _tmpLogDate;
        _tmpLogDate = _cursor.getLong(_cursorIndexOfLogDate);
        _item.setLogDate(_tmpLogDate);
        final long _tmpTimeRecorded;
        _tmpTimeRecorded = _cursor.getLong(_cursorIndexOfTimeRecorded);
        _item.setTimeRecorded(_tmpTimeRecorded);
        final boolean _tmpClazzLogDone;
        final int _tmp;
        _tmp = _cursor.getInt(_cursorIndexOfClazzLogDone);
        _tmpClazzLogDone = _tmp != 0;
        _item.setClazzLogDone(_tmpClazzLogDone);
        final String _tmpCancellationNote;
        if (_cursor.isNull(_cursorIndexOfCancellationNote)) {
          _tmpCancellationNote = null;
        } else {
          _tmpCancellationNote = _cursor.getString(_cursorIndexOfCancellationNote);
        }
        _item.setCancellationNote(_tmpCancellationNote);
        final boolean _tmpClazzLogCancelled;
        final int _tmp_1;
        _tmp_1 = _cursor.getInt(_cursorIndexOfClazzLogCancelled);
        _tmpClazzLogCancelled = _tmp_1 != 0;
        _item.setClazzLogCancelled(_tmpClazzLogCancelled);
        final int _tmpClazzLogNumPresent;
        _tmpClazzLogNumPresent = _cursor.getInt(_cursorIndexOfClazzLogNumPresent);
        _item.setClazzLogNumPresent(_tmpClazzLogNumPresent);
        final int _tmpClazzLogNumAbsent;
        _tmpClazzLogNumAbsent = _cursor.getInt(_cursorIndexOfClazzLogNumAbsent);
        _item.setClazzLogNumAbsent(_tmpClazzLogNumAbsent);
        final int _tmpClazzLogNumPartial;
        _tmpClazzLogNumPartial = _cursor.getInt(_cursorIndexOfClazzLogNumPartial);
        _item.setClazzLogNumPartial(_tmpClazzLogNumPartial);
        final long _tmpClazzLogScheduleUid;
        _tmpClazzLogScheduleUid = _cursor.getLong(_cursorIndexOfClazzLogScheduleUid);
        _item.setClazzLogScheduleUid(_tmpClazzLogScheduleUid);
        final int _tmpClazzLogStatusFlag;
        _tmpClazzLogStatusFlag = _cursor.getInt(_cursorIndexOfClazzLogStatusFlag);
        _item.setClazzLogStatusFlag(_tmpClazzLogStatusFlag);
        final long _tmpClazzLogMSQN;
        _tmpClazzLogMSQN = _cursor.getLong(_cursorIndexOfClazzLogMSQN);
        _item.setClazzLogMSQN(_tmpClazzLogMSQN);
        final long _tmpClazzLogLCSN;
        _tmpClazzLogLCSN = _cursor.getLong(_cursorIndexOfClazzLogLCSN);
        _item.setClazzLogLCSN(_tmpClazzLogLCSN);
        final int _tmpClazzLogLCB;
        _tmpClazzLogLCB = _cursor.getInt(_cursorIndexOfClazzLogLCB);
        _item.setClazzLogLCB(_tmpClazzLogLCB);
        final long _tmpClazzLogLastChangedTime;
        _tmpClazzLogLastChangedTime = _cursor.getLong(_cursorIndexOfClazzLogLastChangedTime);
        _item.setClazzLogLastChangedTime(_tmpClazzLogLastChangedTime);
        _result.add(_item);
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public ScheduledCheck findByUid(final long uid) {
    final String _sql = "SELECT * FROM ScheduledCheck WHERE scheduledCheckUid = ?";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 1);
    int _argIndex = 1;
    _statement.bindLong(_argIndex, uid);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfScheduledCheckUid = CursorUtil.getColumnIndexOrThrow(_cursor, "scheduledCheckUid");
      final int _cursorIndexOfCheckTime = CursorUtil.getColumnIndexOrThrow(_cursor, "checkTime");
      final int _cursorIndexOfCheckType = CursorUtil.getColumnIndexOrThrow(_cursor, "checkType");
      final int _cursorIndexOfCheckUuid = CursorUtil.getColumnIndexOrThrow(_cursor, "checkUuid");
      final int _cursorIndexOfCheckParameters = CursorUtil.getColumnIndexOrThrow(_cursor, "checkParameters");
      final int _cursorIndexOfScClazzLogUid = CursorUtil.getColumnIndexOrThrow(_cursor, "scClazzLogUid");
      final int _cursorIndexOfScheduledCheckMasterCsn = CursorUtil.getColumnIndexOrThrow(_cursor, "scheduledCheckMasterCsn");
      final int _cursorIndexOfScheduledCheckLocalCsn = CursorUtil.getColumnIndexOrThrow(_cursor, "scheduledCheckLocalCsn");
      final int _cursorIndexOfScheduledCheckLastChangedBy = CursorUtil.getColumnIndexOrThrow(_cursor, "scheduledCheckLastChangedBy");
      final int _cursorIndexOfScheduledCheckLct = CursorUtil.getColumnIndexOrThrow(_cursor, "scheduledCheckLct");
      final ScheduledCheck _result;
      if(_cursor.moveToFirst()) {
        _result = new ScheduledCheck();
        final long _tmpScheduledCheckUid;
        _tmpScheduledCheckUid = _cursor.getLong(_cursorIndexOfScheduledCheckUid);
        _result.setScheduledCheckUid(_tmpScheduledCheckUid);
        final long _tmpCheckTime;
        _tmpCheckTime = _cursor.getLong(_cursorIndexOfCheckTime);
        _result.setCheckTime(_tmpCheckTime);
        final int _tmpCheckType;
        _tmpCheckType = _cursor.getInt(_cursorIndexOfCheckType);
        _result.setCheckType(_tmpCheckType);
        final String _tmpCheckUuid;
        if (_cursor.isNull(_cursorIndexOfCheckUuid)) {
          _tmpCheckUuid = null;
        } else {
          _tmpCheckUuid = _cursor.getString(_cursorIndexOfCheckUuid);
        }
        _result.setCheckUuid(_tmpCheckUuid);
        final String _tmpCheckParameters;
        if (_cursor.isNull(_cursorIndexOfCheckParameters)) {
          _tmpCheckParameters = null;
        } else {
          _tmpCheckParameters = _cursor.getString(_cursorIndexOfCheckParameters);
        }
        _result.setCheckParameters(_tmpCheckParameters);
        final long _tmpScClazzLogUid;
        _tmpScClazzLogUid = _cursor.getLong(_cursorIndexOfScClazzLogUid);
        _result.setScClazzLogUid(_tmpScClazzLogUid);
        final long _tmpScheduledCheckMasterCsn;
        _tmpScheduledCheckMasterCsn = _cursor.getLong(_cursorIndexOfScheduledCheckMasterCsn);
        _result.setScheduledCheckMasterCsn(_tmpScheduledCheckMasterCsn);
        final long _tmpScheduledCheckLocalCsn;
        _tmpScheduledCheckLocalCsn = _cursor.getLong(_cursorIndexOfScheduledCheckLocalCsn);
        _result.setScheduledCheckLocalCsn(_tmpScheduledCheckLocalCsn);
        final int _tmpScheduledCheckLastChangedBy;
        _tmpScheduledCheckLastChangedBy = _cursor.getInt(_cursorIndexOfScheduledCheckLastChangedBy);
        _result.setScheduledCheckLastChangedBy(_tmpScheduledCheckLastChangedBy);
        final long _tmpScheduledCheckLct;
        _tmpScheduledCheckLct = _cursor.getLong(_cursorIndexOfScheduledCheckLct);
        _result.setScheduledCheckLct(_tmpScheduledCheckLct);
      } else {
        _result = null;
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
